EXT_DELAYER_ACL(1)

NAME
 delayer - Squid external ACL helper adding artificial delay to requests

SYNOPSIS
 delayer [--help] [--debug] [--log file] [--wait msec]

DESCRIPTION
Squid external acl helper; causes squid to delay responding to HTTP requests.

By carefully crafting the ACLs of a Squid setup it is possible to selectively delay requests received by a proxy. After the configured amount of time, it will always return "true".

OPTIONS

--help or -h
    Print help message to stdout

--debug or -d
    Emit debugging output to STDERR and ultimately cache.log

--log /path/to/file or -l /path/to/file
    Emit debugging output to specified file instead of STDERR. Also turns on debugging

--wait msec or -w msec
    Delay each request by the specified amount of msec. Unless this option is specified, by default each submitted request will be delayed by half a second (500 msec).

CONFIGURATION
To engage it, this snippet of configuration template can be used in squid.conf:

 external_acl_type delayer concurrency=100000 children-max=2 children-startup=1 children-idle=1 cache=10 %URI /path/to/delayer -w 200
 acl delay external delayer
 http_access allow acl1 acl2 acl3 delay !all

It is important that the acl referencing the delayer be the penultimate clause in the http_access line. It will cause delay to all requests that match all the preceding acls in the line. The !all clause at the end of the line will make it so that no traffic is authorized by this ACL, only the delay to evaluate the delay clause will be inserted before evaluating following http_access lines. It is also important to place the http_access line carefully in the sequence of all http_access_lines; it should be near the beginning, but be careful not to insert unwanted slow acls (especially proxy_auth).

It is possible to customize how delay is calculated for each request by modifying the "calc_delay" PERL function in the script, documentation on this is embedded in the source code comments.

AUTHOR
This software is written by Francesco Chemolli <kinkie@squid-cache.org>

COPYRIGHT
 * Copyright (C) 1996-2015 The Squid Software Foundation and contributors
 *
 * Squid software is distributed under GPLv2+ license and includes
 * contributions from numerous individuals and organizations.
 * Please see the COPYING and CONTRIBUTORS files for details.

 (C) 2014 Francesco Chemolli <kinkie@squid-cache.org>

 This program is free software. You may redistribute copies of it under the
 terms of the GNU General Public License version 2, or (at your opinion) any
 later version.

QUESTIONS
Questions on the usage of this program can be sent to the Squid Users mailing list <squid-users@squid-cache.org>

REPORTING BUGS
Bug reports need to be made in English. See http://wiki.squid-cache.org/SquidFaq/BugReporting for details of what you need to include with your bug report.

Report bugs or bug fixes using http://bugs.squid-cache.org/

Report serious security bugs to Squid Bugs <squid-bugs@squid-cache.org>

Report ideas for new improvements to the Squid Developers mailing list <squid-dev@squid-cache.org>

SEE ALSO
squid (8), GPL \fIs0(7),

The Squid FAQ wiki http://wiki.squid-cache.org/SquidFaq

The Squid Configuration Manual http://www.squid-cache.org/Doc/config/